//Data saving/loading
//SAVING AND READING SETTINGS

#include "data_manager.h"

//save function
void write2file(gboolean control) {

	FILE *systray;
	char path[150];
	sprintf(path,"%s/systray.conf", xchat_get_info(ph, "xchatdir"));
	systray = fopen(path,"w");
	if (systray != NULL) {
		fprintf(systray,"%s\n",imagepath1);
		fprintf(systray,"%s\n",bpath1);
		fprintf(systray,"%s\n",epath1);
		fprintf(systray,"%s\n",ppath1);
		fprintf(systray,"%s\n",amsg1);
		fprintf(systray,"%s\n",amsg2);
		fprintf(systray,"%s\n",amsg3);
		fprintf(systray,"%s\n",awaynick);
		fprintf(systray,"%s\n",awaypass);
#ifndef _WIN32_
		if (KDE ==TRUE) fprintf(systray,"1\n");
		else fprintf(systray,"0\n");
#endif
		if (go_change== TRUE) fprintf(systray,"1\n");
		else fprintf(systray,"0\n");
		if (go_identify== TRUE) fprintf(systray,"1\n");
		else fprintf(systray,"0\n");
		if (highlight== TRUE) fprintf(systray,"1\n");
		else fprintf(systray,"0\n");
		if (query== TRUE) fprintf(systray,"1\n");
		else fprintf(systray,"0\n");
		if (disconnection== TRUE) fprintf(systray,"1\n");
		else fprintf(systray,"0\n");
		if (killevent== TRUE) fprintf(systray,"1\n");
		else fprintf(systray,"0\n");
		if (kick== TRUE) fprintf(systray,"1\n");
		else fprintf(systray,"0\n");
		if (dcc_chat== TRUE) fprintf(systray,"1\n");
		else fprintf(systray,"0\n");
		if (dcc_send== TRUE) fprintf(systray,"1\n");
		else fprintf(systray,"0\n");
		if (invite== TRUE) fprintf(systray,"1\n");
		else fprintf(systray,"0\n");
		if (notify_list== TRUE) fprintf(systray,"1\n");
		else fprintf(systray,"0\n");
		fprintf(systray,"%d\n",flash_interval);

		if (control) xchat_printf(ph,"Successfully saved settings to file.\n");
		fclose(systray);
	} else {
		xchat_printf(ph,"Error writing to file %s.\n", path);
	}
}

//get apps path & settings
void systray_get_info (gboolean onstart_warning,gboolean control) {
	FILE *systray;
	char path[150];
	int len,check;
	sprintf(path,"%s/systray.conf", xchat_get_info(ph, "xchatdir"));
	systray = fopen(path,"r");
	if (systray != NULL) {
		//cut off the "\n" value
		fgets(imagepath,150,systray);
		len=strlen(imagepath); if ( len && imagepath[len-1] == '\n' ) imagepath[len-1] = 0;
		fgets(bpath,150,systray);
		len=strlen(bpath); if ( len && bpath[len-1] == '\n' ) bpath[len-1] = 0;
		fgets(epath,150,systray);
		len=strlen(epath); if ( len && epath[len-1] == '\n' ) epath[len-1] = 0;
		fgets(ppath,150,systray);
		len=strlen(ppath); if ( len && ppath[len-1] == '\n' ) ppath[len-1] = 0;
		fgets(away_msg1,150,systray);
		len=strlen(away_msg1); if ( len && away_msg1[len-1] == '\n' ) away_msg1[len-1] = 0;
		fgets(away_msg2,150,systray);
		len=strlen(away_msg2); if ( len && away_msg2[len-1] == '\n' ) away_msg2[len-1] = 0;
		fgets(away_msg3,150,systray);
		len=strlen(away_msg3); if ( len && away_msg3[len-1] == '\n' ) away_msg3[len-1] = 0;
		fgets(away_nick,150,systray);
		len=strlen(away_nick); if ( len && away_nick[len-1] == '\n' ) away_nick[len-1] = 0;
		fgets(away_pass,150,systray);
		len=strlen(away_pass); if ( len && away_pass[len-1] == '\n' ) away_pass[len-1] = 0;
#ifndef _WIN32_
		fscanf(systray,"%d",&check);
		if ( check== 1 ) KDE=TRUE;
		else KDE=FALSE;
#endif
		fscanf(systray,"%d",&check);
		if ( check== 1 ) go_change=TRUE;
		else go_change=FALSE;

		fscanf(systray,"%d",&check);
		if ( check== 1 ) go_identify=TRUE;
		else go_identify=FALSE;

		fscanf(systray,"%d",&check);
		if ( check== 1 ) highlight=TRUE;
		else highlight=FALSE;

		fscanf(systray,"%d",&check);
		if ( check== 1 ) query=TRUE;
		else query=FALSE;

		fscanf(systray,"%d",&check);
		if ( check== 1 ) disconnection=TRUE;
		else disconnection=FALSE;

		fscanf(systray,"%d",&check);
		if ( check== 1 ) killevent=TRUE;
		else killevent=FALSE;

		fscanf(systray,"%d",&check);
		if ( check== 1 ) kick=TRUE;
		else kick=FALSE;

		fscanf(systray,"%d",&check);
		if ( check== 1 ) dcc_chat=TRUE;
		else dcc_chat=FALSE;

		fscanf(systray,"%d",&check);
		if ( check== 1 ) dcc_send=TRUE;
		else dcc_send=FALSE;

		fscanf(systray,"%d",&check);
		if ( check== 1 ) invite=TRUE;
		else invite=FALSE;

		fscanf(systray,"%d",&check);
		if ( check== 1 ) notify_list=TRUE;
		else notify_list=FALSE;

		fscanf(systray,"%d",&check);
		flash_interval=check;

		if (control) xchat_printf(ph,"Successfully loaded settings from file.\n");
		fclose(systray);
	}
	else if (onstart_warning) {
			xchat_printf(ph,"Error opening file %s.\n", path);
			show_warning();
		}

}

// calls saving function and updates variables
void save(){

#ifndef _WIN32_
	if (window_manager_modified!=KDE) show_win_manager_warning();
#endif
	xchat_printf(ph, "These are your selected application paths & settings:\n");
	imagepath1 = gtk_entry_get_text( GTK_ENTRY(imagepath_text) );
	xchat_printf(ph,"Icons path: %s", imagepath1);
	bpath1= gtk_entry_get_text( GTK_ENTRY(browser_text) );
	xchat_printf(ph, "Browser: %s",bpath1);
	epath1= gtk_entry_get_text( GTK_ENTRY(email_text) );
	xchat_printf(ph, "Email Client: %s",epath1);
	ppath1= gtk_entry_get_text( GTK_ENTRY(player_text) );
	xchat_printf(ph, "Multimedia Player: %s",ppath1);
	amsg1= gtk_entry_get_text( GTK_ENTRY(away1) );
	xchat_printf(ph, "Your first favourite away message: %s",amsg1);
	amsg2= gtk_entry_get_text( GTK_ENTRY(away2) );
	xchat_printf(ph, "Your second favourite away message: %s",amsg2);
	amsg3= gtk_entry_get_text( GTK_ENTRY(away3) );
	xchat_printf(ph, "Your third favourite away message: %s",amsg3);
	awaynick=gtk_entry_get_text( GTK_ENTRY(away_nick_box) );
	awaypass=gtk_entry_get_text( GTK_ENTRY(away_nick_pass_box) );
	if (go_change==TRUE) {
		xchat_printf(ph, "While in away, you want to change your nick in: %s",awaynick);
		if ( go_identify == TRUE ) {

			xchat_printf(ph, "Your away nick password is: %s",awaypass);
		}
		else xchat_printf(ph, "Your away nick doesn't need to be identified.");
	}
	else xchat_printf(ph, "While in away, you don't want to change your nick.");
	if (highlight==TRUE) xchat_printf(ph, "HighLight Messages Event Notification: on"); else xchat_printf(ph, "HighLight Messages Event Notification: off");
	if (query==TRUE) xchat_printf(ph, "Query Event Notification: on"); else xchat_printf(ph, "Query Event Notification: off");
	if (disconnection==TRUE) xchat_printf(ph, "Disconnection Event Notification: on"); else xchat_printf(ph, "Disconnection Event Notification: off");
	if (killevent==TRUE) xchat_printf(ph, "Kill Event Notification: on"); else xchat_printf(ph, "Kill Event Notification: off");
	if (kick==TRUE) xchat_printf(ph, "Kick Event Notification: on"); else xchat_printf(ph, "Kick Event Notification: off");
	if (dcc_chat==TRUE) xchat_printf(ph, "DCC Chat Event Notification: on"); else xchat_printf(ph, "DCC Chat Event Notification: off");
	if (dcc_send==TRUE) xchat_printf(ph, "DCC Send Event Notification: on"); else xchat_printf(ph, "DCC Send Event Notification: off");
	if (invite==TRUE) xchat_printf(ph, "Invite Event Notification: on"); else xchat_printf(ph, "Invite Event Notification: off");
	if (notify_list==TRUE) xchat_printf(ph, "Notify List Event Notification: on"); else xchat_printf(ph, "Notify List Event Notification: off");

	xchat_printf(ph, "Selected Tray Flashing Timeout: %d",flash_interval);
#ifndef _WIN32_
	if (KDE) xchat_printf(ph,"Your Window Manager has KDE like style");
	else xchat_printf(ph,"Your Window Manager has Gnome like style");
#endif
	xchat_print(ph, "\nIf you want to change settings, please select Settings again.");
	write2file(TRUE);
	systray_get_info(FALSE,FALSE);
}


